#ifndef ZASM_STRING_ALLOC_H
#define ZASM_STRING_ALLOC_H 1

#include <zasm/alloc.h>

#define STRING_ALLOC_T(O) ((struct string_alloc_t *)(O))
struct string_alloc_t
{
  struct alloc_t alloc;
  char *data[ALLOC_DEF_COUNT];
};

#include <zasm/string.h>
struct string_alloc_t *string_alloc_new();
void string_alloc_fill(struct string_alloc_t *alloc);
char *string_alloc_copy(struct string_alloc_t **alloc, char *string);
void string_alloc_reset(struct string_alloc_t *alloc);
void string_alloc_delete(struct string_alloc_t *alloc);
void string_alloc_free(struct string_alloc_t *alloc);

#endif
