#ifndef ZASM_WRITER_H
#define ZASM_WRITER_H 1

#include <stdio.h>
#include <zasm/stream.h>
#include <zasm/feeder.h>

#define WRITER_T(O) ((struct writer_t *)(O))
struct writer_t
{
  FILE *output;
};

struct writer_t *writer_new(char *filename);
void writer_fill(struct writer_t *writer, char *filename);
void writer_change(struct writer_t *writer, char *filename);
void writer_execute(struct feeder_t *input, struct stream_t *output, struct writer_t *writer);
void writer_delete(struct writer_t *writer);
void writer_free(struct writer_t *writer);

#endif
